﻿//////////////////////////////////////////////
// RenderQueueManagerWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT RenderQueueManagerWrapper final
	{
		private :

			// Constructeur, destructeur
			RenderQueueManagerWrapper () = delete ;
			~RenderQueueManagerWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Functions
			static nkScripts::OutputValue createOrRetrieveIndex (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue createOrRetrieveName (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getName (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getIndex (const nkScripts::DataStack& stack) ;
	} ;
}