﻿//////////////////////////////////////////////
// ExportError.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkExport
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>
#include <NilkinsMemory/Containers/String.h>

/// Class ------------------------------------
	
namespace nkExport
{
	class DLL_EXPORT_EXPORT ExportError final
	{
		private :

			// Attributs
			// Description
			nkMemory::String _errorDesc ;
			nkMemory::String _errorInfo ;
			// Offsets pour retrouver 
			unsigned int _index ;

			// Si on a ete activee
			bool _activated ;
		
		public :
		
			// Constructeur, destructeur
			ExportError () ;
			ExportError (const nkMemory::StringView& errorDesc, const nkMemory::StringView& errorInfos, unsigned int index) ;
			~ExportError () ;

			// Setters
			void setErrorDesc (const nkMemory::StringView& desc) ;
			void setErrorInfo (const nkMemory::StringView& infos) ;
			void setIndex (unsigned int index) ;
			void setActivated (bool value) ;

			// Getters
			nkMemory::StringView getErrorDesc () const ;
			nkMemory::StringView getErrorInfo () const ;
			unsigned int getIndex () const ;
			bool isActivated () const ;
	} ;
}