﻿//////////////////////////////////////////////
// MapRequestDescriptor.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "../Utilities/DxDefinesWrapper.h"

/// Internals --------------------------------

namespace nkGraphics
{
	struct BufferSubResourceDescriptor
	{
		unsigned int _subResourceIndex = 0 ;
	} ;

	struct TextureSubResourceDescriptor
	{
		unsigned int _indexInArray = 0 ;
		unsigned int _mipIndex = 0 ;
	} ;
}

/// Class ------------------------------------

namespace nkGraphics
{
	struct DLL_GRAPHICS_EXPORT MapRequestDescriptor
	{
		// Map type wanted
		MAP _mapType = MAP_WRITE_DISCARD ;

		// Which sub resource should be mapped
		union
		{
			BufferSubResourceDescriptor _buffer ;
			TextureSubResourceDescriptor _texture = TextureSubResourceDescriptor() ;
		} ;

		// Constructor and destructor explicit
		MapRequestDescriptor ()
		:	_mapType (MAP_WRITE_DISCARD),
			_texture ()
		{
			// Nothing to do
		}

		~MapRequestDescriptor ()
		{
			// Nothing to do
		}
	} ;
}