﻿//////////////////////////////////////////////
// HashHelper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <functional>

/// Class ------------------------------------

namespace nkGraphics
{
	class HashHelper final
	{
		private :

			// Functions
			// Constructeur, destructeur
			HashHelper () = delete ;
			~HashHelper () = delete ;

		public :

			// Combinaisons de hashs
			static unsigned long long combine (unsigned long long hash0, unsigned long long hash1)
			{
				return hash0 ^ (hash1 + 0x9e3779b9 + (hash0 << 6) + (hash0 >> 2)) ;
			}

			template <typename T>
			static unsigned long long combine (unsigned long long hash0, T number1)
			{
				return combine(hash0, (unsigned long long)std::hash<T>()(number1)) ;
			}

			template <>
			static unsigned long long combine (unsigned long long hash0, nkMemory::StringView number1)
			{
				return combine<unsigned long long>(hash0, (unsigned long long)std::hash<std::string_view>()(number1)) ;
			}
	} ;
}