﻿//////////////////////////////////////////////
// MeshLoader.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Node ;
}

namespace nkGraphics
{
	class Mesh ;
	class MeshLoadQuery ;
	class MeshLoadResult ;
	class MeshSaveQuery ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/BufferView.h>
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkGraphics
{	
	class DLL_GRAPHICS_EXPORT MeshLoader final
	{
		private :

			// Constructor, destructor
			MeshLoader () = delete ;
			~MeshLoader () = delete ;
		
		public :
		
			// Fill
			static bool fillBufferFromFile (Mesh* mesh, const nkMemory::StringView& pathFromData) ;
			static bool fillBufferFromData (Mesh* mesh, const nkMemory::BufferView<>& data) ;

			// Generic load
			static MeshLoadResult loadMesh (const MeshLoadQuery& query) ;
	} ;
}