﻿//////////////////////////////////////////////
// GlesDataAllocator.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../DataAllocator.h"

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesDataAllocator final : public nkGraphics::DataAllocator
	{
		public :
				
			// Constructor, destructor
			GlesDataAllocator () ;
			~GlesDataAllocator () ;

			// Allocations
			virtual Buffer* allocateBuffer () override ;

			virtual Mesh* allocateMesh () override ;

			virtual BlendState* allocateBlendState () override ;
			virtual DepthStencilState* allocateDepthStencilState () override ;
			virtual RasterState* allocateRasterState () override ;

			virtual Sampler* allocateSampler () override ;
			virtual Texture* allocateTexture () override ;

			virtual Compositor* allocateCompositor () override ;

			virtual ClearTargetsPass* allocateClearTargetsPass () override ;
			virtual ComputePass* allocateComputePass () override ;
			virtual InstancingPass* allocateInstancingPass () override ;
			virtual MonoMaterialPass* allocateMonoMaterialPass () override ;
			virtual PostProcessPass* allocatePostProcessPass () override ;
			virtual RaytracingPass* allocateRaytracingPass () override ;
			virtual RenderScenePass* allocateRenderScenePass () override ;

			virtual Viewport* allocateViewport () override ;

			virtual RenderContext* allocateRenderContext () override ;

			virtual RenderQueue* allocateRenderQueue () override ;

			virtual Program* allocateProgram () override ;

			virtual Shader* allocateShader () override ;

			virtual ProfilingHelper* allocateProfilingHelper () override ;
	} ;
}
