﻿//////////////////////////////////////////////
// GlesProgram.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

typedef unsigned int GLuint ;

/// Includes ---------------------------------

// nkGraphics
#include "../../../Programs/Program.h"

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesProgram final : public Program
	{
		private :

			// Attributes
			// Program id
			GLuint _programId ;

			// Found uniform blocks inside
			unsigned int _uniformBlockCount ;

		private :

			// Functions
			// Bindings & semantics
			void _parseBindings () ;
			void _parseSemantics () ;

		public :

			// Constructor, destructor
			GlesProgram () ;
			~GlesProgram () ;

			// Getters
			unsigned int getProgramId () const ;
			unsigned int getUniformBlockCount () const ;

			// Loading
			virtual bool loadFromMemory () override ;
			virtual bool tryToLoadFrom (ProgramSourcesHolder& newMemory) override ;
			virtual void unload () override ;
	} ;
}