﻿//////////////////////////////////////////////
// KeyboardDeviceManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkInputs
{
	class MouseDevice ;
}

/// Includes ---------------------------------

// nkInputs
#include "../../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <unordered_map>

/// Class ------------------------------------

namespace nkInputs
{
	class DLL_INPUTS_EXPORT MouseDeviceManager final : public nkCommon::SingletonClass<MouseDeviceManager>
	{
		friend class nkCommon::SingletonClass<MouseDeviceManager> ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, MouseDevice*> _devices ;

		private :

			// Functions
			// Constructor, destructor
			MouseDeviceManager () ;
			~MouseDeviceManager () ;

		public :

			// Memory Management
			MouseDevice* createOrRetrieve (const nkMemory::StringView& name) ;
			MouseDevice* get (const nkMemory::StringView& name) ;
			void rename (const nkMemory::StringView& currentName, const nkMemory::StringView& newName) ;
			void erase (const nkMemory::StringView& name) ;
	} ;
}